---
title: '@document'
slug: Web/CSS/@document
tags:
  - At-rule
  - CSS
  - Reference
---
<div>{{CSSRef}}{{Deprecated_header}}</div>

<p>The <strong><code>@document</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/At-rule">at-rule</a> restricts the style rules contained within it based on the URL of the document. It is designed primarily for user-defined style sheets, though it can be used on author-defined style sheets, too.</p>

<pre class="brush: css no-line-numbers notranslate">@document url("https://www.example.com/") {
  h1 {
    color: green;
  }
}
</pre>

<h2 id="Syntax">Syntax</h2>

<p>An <code>@document</code> rule can specify one or more matching functions. If any of the functions apply to a given URL, the rule will take effect on that URL. The functions available are:</p>

<ul>
 <li><code>url()</code>, which matches an exact URL.</li>
 <li><code>url-prefix()</code>, which matches if the document URL starts with the value provided.</li>
 <li><code>domain()</code>, which matches if the document URL is on the domain provided (or a subdomain of it).</li>
 <li><code>media-document()</code>, with the parameter of video, image, plugin or all.</li>
 <li><code>regexp()</code>, which matches if the document URL is matched by the <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">regular expression</a> provided. The expression must match the entire URL.</li>
</ul>

<p>The values provided to the <code>url()</code>, <code>url-prefix()</code>, <code>domain()</code>, and <code>media-document()</code> functions can be optionally enclosed by single or double quotes. The values provided to the <code>regexp()</code> function <em>must</em> be enclosed in quotes.</p>

<p>Escaped values provided to the <code>regexp()</code> function must additionally be escaped from the CSS. For example, a <code>.</code> (period) matches any character in regular expressions. To match a literal period, you would first need to escape it using regular expression rules (to <code>\.</code>), then escape that string using CSS rules (to <code>\\.</code>).</p>

<p><code>@document</code> is currently only supported in Firefox; if you wanted to replicate using such functionality in your own non-Firefox browser, you could try using <a href="https://github.com/An-Error94/Handy-Scripts/tree/master/%40document-polyfill">this polyfill</a> by @An-Error94, which uses a combination of a user script, <a href="/en-US/docs/Web/HTML/Global_attributes/data-*">data-* attributes</a>, and <a href="/en-US/docs/Web/CSS/Attribute_selectors">attribute selectors</a>.</p>

<div class="note">
<p><strong>Note</strong>: There is a -moz-prefixed version of this property — <code>@-moz-document</code>. This has been limited to use only in user and UA sheets in Firefox 59 in Nightly and Beta — an experiment designed to mitigate potential CSS injection attacks (See {{bug(1035091)}}).</p>
</div>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Specifying_document_for_CSS_rule">Specifying document for CSS rule</h3>

<pre class="brush: css notranslate">@document url("http://www.w3.org/"),
          url-prefix("http://www.w3.org/Style/"),
          domain("mozilla.org"),
          media-document("video"),
          regexp("https:.*") {
  /* CSS rules here apply to:
     - The page "http://www.w3.org/"
     - Any page whose URL begins with "http://www.w3.org/Style/"
     - Any page whose URL's host is "mozilla.org"
       or ends with ".mozilla.org"
     - Any standalone video
     - Any page whose URL starts with "https:" */

  /* Make the above-mentioned pages really ugly */
  body {
    color: purple;
    background: yellow;
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<p><a href="http://www.w3.org/TR/2012/WD-css3-conditional-20120911/#at-document">Initially</a> in {{SpecName('CSS3 Conditional')}}, <code>@document</code> has been <a href="http://www.w3.org/TR/2012/WD-css3-conditional-20121213/#changes">postponed</a> to Level 4 then removed.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.document")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a class="external" href="http://lists.w3.org/Archives/Public/www-style/2004Aug/0135">Per-site user style sheet rules</a> on the www-style mailing list.</li>
</ul>
